%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                  %
%    DAEdalon Finite-Element-Project                               %
%                                                                  %
%    Copyright 2002/2003 Steffen Eckert                            %
%    Contact: http://www.daedalon.org                              %
%                                                                  %
%                                                                  %
%    This file is part of DAEdalon.                                %
%                                                                  %
%    DAEdalon is free software; you can redistribute it            %
%    and/or modify it under the terms of the GNU General           %
%    Public License as published by the Free Software Foundation;  %
%    either version 2 of the License, or (at your option)          %
%    any later version.                                            %
%                                                                  %
%    DAEdalon is distributed in the hope that it will be           %
%    useful, but WITHOUT ANY WARRANTY; without even the            %
%    implied warranty of MERCHANTABILITY or FITNESS FOR A          %
%    PARTICULAR PURPOSE.  See the GNU General Public License       %
%    for more details.                                             %
%                                                                  %
%    You should have received a copy of the GNU General            %
%    Public License along with Foobar; if not, write to the        %
%    Free Software Foundation, Inc., 59 Temple Place, Suite 330,   %
%    Boston, MA  02111-1307  USA                                   %
%                                                                  %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% dae.m

% ndm     Anzahl der Dimensionen
% numnp   Anzahl der Gesamtknoten
% numel   Anzahl der Elemente im Problem
% nel     Anzahl der Knoten pro Element
% ndf     Freiheitsgrade pro Knoten (nicht immer gleich ndm)
% gesdof  Anzahl der Gesamtfreiheitsgrade 
% numgp_max   Max. Anzahl der verwendeten Gausspunkte pro Element
% nummat  Anzahl der unterschiedlichen verwendeten Materialgesetze

clear all

% Pfade absolut setzen
aP = [pwd,'/'];

% Pfade hinzufgen
addpath([aP,'plot'])
addpath([aP,'input'])
addpath([aP,'elem'])
addpath([aP,'mat'])
addpath([aP,'dynamics'])
addpath([aP,'post'])
addpath([aP,'output'])
addpath([aP,'logo'])
addpath([aP,'rst_files'])

% AMINEM: Pfade fuer GUI
addpath([aP,'gui'])
addpath([aP,'gui/gui_pre'])
addpath([aP,'gui/gui_prog'])
addpath([aP,'gui/gui_plot'])
addpath([aP,'gui/gui_post'])
addpath([aP,'gui/gui_opt'])

% aT: Bogenlaengenverfahren
addpath([aP,'arcLength'])

setGloVar;

% gui initialisieren
crf
gui_setup
